#include<iostream>
#include<fstream>
#include<algorithm>
#include<cstdio>
#include<cmath>
#include<cstdlib>
#include<cstring>
#include<string>
#include<vector>
#include<stack>
#include<queue>
#include<map>

#define Inf 200000000

using namespace std;

fstream fin ( "graph.in" ) ;
ofstream fout ( "graph.out" ) ;

struct yo
{
  int x;
  int y;
  int cost;
};

struct po
{
  int y;
  int cost;
};

int used[1024],d[1024],w[1024],Start_Node=1,n,m , rr[1024][1024];

vector < yo > Tree;

vector < po > v[1024];

void Read ()
{
  int p,q,i , j , t ;
  po T;
  cin >> n >> m ; ///scanf ("%d%d",&n,&m);
  for (i=0;i<m;i++)
  {
    cin >> p >> q >> T.cost ; ///scanf ("%d%d%d",&p,&q,&T.cost);
    rr [ p ] [ q ] = i + 1 ;
    rr [ q ] [ p ] = i + 1 ;
    T.y=q;
    v[p].push_back (T);
    T.y=p;
    v[q].push_back (T);
  }
  for ( i = 0 ; i < n ; i ++ )
    for ( j = 0 ; j < n ; j ++ )
    cin >> t ;
  return ;
}

void Prim ()
{
  int sz,i,j,x,y;

  yo MinV;

  sz=v[Start_Node].size ();

  used[Start_Node]=1;

  for (i=1;i<=n;i++)
  {
    d[i]=Inf;
    w[i]=0;
  }

  for (i=0;i<sz;i++)
  {
    d[v[Start_Node][i].y]=v[Start_Node][i].cost;
    w[v[Start_Node][i].y]=Start_Node;
  }

  for (j=1;j<n;j++)
  {
    MinV.cost=Inf;

    for (i=1;i<=n;i++)
    if (!used[i]&&d[i]<MinV.cost)
    {
      MinV.cost=d[i];
      MinV.x=i;
      MinV.y=w[i];
    }

    used[MinV.x]=1;

    Tree.push_back (MinV);

    sz=v[MinV.x].size ();

    Start_Node=MinV.x;

    ///printf ("%d %d %d\n",MinV.x,MinV.y,MinV.cost);

    for (i=0;i<sz;i++)
    if (!used[v[Start_Node][i].y]&&d[v[Start_Node][i].y]>v[Start_Node][i].cost)
    {
      d[v[Start_Node][i].y]=v[Start_Node][i].cost;
      w[v[Start_Node][i].y]=Start_Node;
    }

  }

  return ;
}

void Print ()
{
  int i,sz;
  sz=Tree.size ();
  ///printf ("%d\n",sz);
  for (i=0;i<sz;i++)
  cout << rr [ Tree[i].x ] [ Tree[i].y ] << endl ; ///printf ("%d\n",rr [ Tree[i].x ] [ Tree[i].y ] );
  return ;
}

int main ()
{
  Read ();
  Prim ();
  Print ();
	return 0;
}
/**
8 14
1 2 2
1 3 5
1 4 1
2 3 1
3 4 3
3 5 10
4 5 8
4 6 7
4 8 3
5 6 12
5 7 1
5 8 6
6 7 8
8 6 4
**/

